/* ------------------------------------------------------------------------- */
/*
  : 7,    .
  Automatically generated by SNN, Fri Jun 01 22:40:31 2012


  License Agreement:
   -----------------

  Copyright StatSoft Inc., 2000-2001, all rights reserved.
  This source code (Source Code Generated by STATISTICA Neural Networks,
  referred to as 'CG' below) is owned by StatSoft Inc. and is protected
  by United States Copyright laws and international treaty provisions. You
  shall treat the CG like any copyrighted material.
  The CG may not be redistributed or used except in accordance with the
  conditions below.

  The licensee is granted a license to incorporate the CG as embedded
  software in their own hardware and software products, and to distribute an
  unlimited number of such embedded copies as part of this license subject to
  obtaining prior written consent from StatSoft Inc., and subject to
  the conditions listed below.

  Prior consent is required so that StatSoft Inc. can ensure that license
  conditions are not breached, and can track legitimate use of the CG. Consent
  shall not be refused unless StatSoft Inc. reasonably believes that a
  breach of license conditions will occur. Consent shall usually be granted
  within five working days of the request, providing that sufficient details of
  the intended use are given.

  Requests should be sent to SNN Project Director, StatSoft, Inc.,
  2300 East 14th Street, Tulsa OK 74104 USA, FAX: 918-749-2217,
  E-Mail: info@statsoft.com.

  The licensee may modify the CG as they see fit for embedded use, including
  recoding into alternative programming languages, altering the neural network
  architecture and weights, and otherwise modifying the CG, provided that they
  keep intact this copyright and license notice.

  The licensee may distribute products including the compiled version of CG.

  The licensee shall not:-
    Sublicense, rent, lease, or assign any portion of the CG to third parties.
    Allow compiled versions of the CG to be incorporated in products owned
    by third parties.
    Allow access to the CG to third parties.
    Use (implicitly or explicitly) any reference to StatSoft, Inc., STATISTICA,
    STATISTICA Neural Networks, or any trade names used by StatSoft, Inc.
    to describe, promote, or reference products in which CG is used, or which
    benefit from CG.

  Except as expressly stated herein, the CG is provided 'AS IS.' The licensee
  shall be entirely responsible for the selection of the CG and for the
  installation, integration, use of, and results obtained from, the CG.
  In particular, but without limitation, attention is drawn to the issue of
  'limited numeric accuracy,' which implies that results may not be identical to
  those when executing the same network in STATISTICA Neural Networks or through
  its Application Programming Interface.

  All other warranties or conditions, either express or implied, including but
  not limited to implied warranties of merchantability or fitness for a
  particular purpose, with respect to the CG and written information
  accompanying the CG, are excluded from the license.

  No liability for Consequential Damages. To the maximum extent permitted by
  applicable law, in no event shall StatSoft Inc.,
  or the vendor be liable for any damages whatsoever
  (including, without limitation, damages for loss of profits,
  business interruption, loss of information, or any other pecuniary loss)
  arising out of the use or inability to use this product,
  even if the vendor has been advised of the possibility of
  such damages.

  This license and your right to use the CG shall terminate automatically
  if StatSoft, Inc. determines that you violate any part of the agreement
  or if you violate any part of this agreement without the knowledge of
  StatSoft, Inc. In the event of termination, you shall immediately destroy
  all copies of the CG.

  This agreement constitutes the entire agreement between you and StatSoft Inc.,
  and supersedes any prior agreement concerning the CG. It shall
  not be modified except by written agreement dated subsequent to the date of
  this agreement signed by an authorized representative of StatSoft Inc.
  StatSoft Inc. shall not be bound by any provision of any purchase order,
  confirmation, correspondence, or otherwise, unless StatSoft Inc.
  specifically agrees to the provision in writing.

  This agreement shall be considered as a contract made in the United States
  of America and according to United States Law,
  subject to the exclusive jurisdiction of the United States Courts.
*/

/* standard includes. math.h needed for exp() function. */

#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>

#ifndef FALSE
#define FALSE 0
#define TRUE 1
#endif

#define MENUCODE -999


static double 704Thresholds[] =
{

/* layer 1 */
-1.4635160689576485, 2.0508499790661459,

/* layer 2 */
1.4611717867643341

};

static double 704Weights[] =
{

/* layer 1 */
-0.27835116978845692, 0.20577366508201977, 0.30580879204153139, -1.1775149637745705,
-1.3736972573152979, -3.6824572715013426, 0.72734948376391628, 2.3802419522734279,

/* layer 2 */
0.13550978827270002, -2.3330063671708765

};

static double 704Acts[14];

/* ---------------------------------------------------------- */
/*
  704Run - run neural network 704

  Input and Output variables.
  Variable names are listed below in order, together with each
  variable's offset in the data set at the time code was
  generated (if the variable is then available).
  For nominal variables, the numeric code - class name
  conversion is shown indented below the variable name.
  To provide nominal inputs, use the corresponding numeric code.
  Input variables (Offset):
  Var1 (0)
  Var2 (1)
  Var3 (2)
  Var4 (3)

  :
  Var7 (6)

*/
/* ---------------------------------------------------------- */

void 704Run( double inputs[], double outputs[], int outputType )
{
  int i, j, k, u;
  double *w = 704Weights, *t = 704Thresholds;

  /* Process inputs - apply pre-processing to each input in turn,
   * storing results in the neuron activations array.
   */

  /* Input 0: standard numeric pre-processing: linear shift and scale. */
  if ( inputs[0] == -9999 )
    704Acts[0] = 0.066965292771744303;
  else
    704Acts[0] = inputs[0] * 2.3310023310023311 + 0;

  /* Input 1: standard numeric pre-processing: linear shift and scale. */
  if ( inputs[1] == -9999 )
    704Acts[1] = 0.2120467866368029;
  else
    704Acts[1] = inputs[1] * 1.1173184357541899 + 0.18100558659217877;

  /* Input 2: standard numeric pre-processing: linear shift and scale. */
  if ( inputs[2] == -9999 )
    704Acts[2] = 0.87913083908634526;
  else
    704Acts[2] = inputs[2] * 3.8314176245210727 + 1;

  /* Input 3: standard numeric pre-processing: linear shift and scale. */
  if ( inputs[3] == -9999 )
    704Acts[3] = 0.52674059479029267;
  else
    704Acts[3] = inputs[3] * 1.7667844522968197 + 0.58303886925795045;

  /*
   * Process layer 1.
   */

  /* For each unit in turn */
  for ( u=0; u < 2; ++u )
  {
    /*
     * First, calculate post-synaptic potentials, storing
     * these in the 704Acts array.
     */

    /* Initialise hidden unit activation to zero */
    704Acts[4+u] = 0.0;

    /* Accumulate weighted sum from inputs */
    for ( i=0; i < 4; ++i )
      704Acts[4+u] += *w++ * 704Acts[0+i];

    /* Subtract threshold */
    704Acts[4+u] -= *t++;

    /* Now apply the hyperbolic activation function, ( e^x - e^-x ) / ( e^x + e^-x ).
     * Deal with overflow and underflow
     */
    if ( 704Acts[4+u] > 100.0 )
       704Acts[4+u] = 1.0;
    else if ( 704Acts[4+u] < -100.0 )
      704Acts[4+u] = -1.0;
    else
    {
      double e1 = exp( 704Acts[4+u] ), e2 = exp( -704Acts[4+u] );
      704Acts[4+u] = ( e1 - e2 ) / ( e1 + e2 );
    }
  }

  /*
   * Process layer 2.
   */

  /* For each unit in turn */
  for ( u=0; u < 1; ++u )
  {
    /*
     * First, calculate post-synaptic potentials, storing
     * these in the 704Acts array.
     */

    /* Initialise hidden unit activation to zero */
    704Acts[6+u] = 0.0;

    /* Accumulate weighted sum from inputs */
    for ( i=0; i < 2; ++i )
      704Acts[6+u] += *w++ * 704Acts[4+i];

    /* Subtract threshold */
    704Acts[6+u] -= *t++;

  }

  /* Type of output required - selected by outputType parameter */
  switch ( outputType )
  {
    /* The usual type is to generate the output variables */
    case 0:


      /* Post-process output 0, numeric linear scaling */
      outputs[0] = ( 704Acts[6] - -0.11675126903553301 ) / 1.6920473773265652;
      break;

    /* type 1 is activation of output neurons */
    case 1:
      for ( i=0; i < 1; ++i )
        outputs[i] = 704Acts[6+i];
      break;

    /* type 2 is codebook vector of winning node (lowest actn) 1st hidden layer */
    case 2:
      {
        int winner=0;
        for ( i=1; i < 2; ++i )
          if ( 704Acts[4+i] < 704Acts[4+winner] )
            winner=i;

        for ( i=0; i < 4; ++i )
          outputs[i] = 704Weights[4*winner+i];
      }
      break;

    /* type 3 indicates winning node (lowest actn) in 1st hidden layer */
    case 3:
      {
        int winner=0;
        for ( i=1; i < 2; ++i )
          if ( 704Acts[4+i] < 704Acts[4+winner] )
            winner=i;

        outputs[0] = winner;
      }
      break;
  }
}

/* ---------------------------------------------------------- */
/*
  704RunPadded - network 704

  inputs - the input variables, in the same number and order
  as in the data set at the time the code was generated.
  This alternative routine is useful if you want a consistent
  interface for your generated routines, so that the number
  and order of variables is the same for all of them.
  Variables (ones used as inputs marked thus *):
  0)	Var1 *
  1)	Var2 *
  2)	Var3 *
  3)	Var4 *

  :
  Var7 (6)

*/
/* ---------------------------------------------------------- */

void 704RunPadded( double inputs[], double outputs[], int outputType )
{
  double in[4];

  /* Copy inputs */
  in[0]=inputs[0];
  in[1]=inputs[1];
  in[2]=inputs[2];
  in[3]=inputs[3];


  /* Run the network */
  704Run( in, outputs, outputType );
}


/*
  Test harness. Compile including this main() procedure, as
  a windows console program or a DOS program, to interactively
  test that the software functions as expected.
*/

int main(void)
{
  int i, outputType=0, noOutputs=1;
  double inputs[4], outputs[4];

  printf( "\n\n7 test harness program. Enter inputs below\n" );
  printf( "Nominal variables should be numbered starting at 1 (0 for missing)\n" );
  printf( "(e.g. if an input is Gender={male,female}, enter 1 for male, 2 for female)\n" );

  /* Infinite (user-breakable) loop for repeated tests */
start_of_loop:
  while ( 1 )
  {
    /* Get the input pattern */
    for ( i=0; i < 4; ++i )
    {
      printf( "Enter value for input %d: ", i+1 );
      scanf( "%lg", & inputs[i] );

      /* Check for sub-menu */
      if ( inputs[i] == MENUCODE )
      {
        printf( "Control menu. Select output style, or exit:\n" );
        printf( "0. Normal output style (output variable)\n" );
        printf( "1. Output layer activations\n" );
        printf( "2. Codebook vector (usual only for Kohonen networks\n" );
        printf( "3. Winning hidden neuron (ditto only Kohonen)\n" );
        printf( "4. Exit program\n" );
        printf( "> " );
        scanf( "%d", & outputType );
        if ( outputType < 0 || outputType > 3 )
        {
          printf( "\nBye.\n" );
          return 0;
        }
        else
        {
          /* Determine how many outputs there are to display (depends on
           * output type)
           */
          switch ( outputType )
          {
            case 0:
              noOutputs = 1;
              break;

            case 1:
              noOutputs = 1;
              break;

            case 2:
              noOutputs = 4;
              break;

            case 3:
              noOutputs = 1;
              break;
          }
          goto start_of_loop;
        }
      }
    }

    /* Run the neural network */
    704Run( inputs, outputs, outputType );

    /* Display the output of the neural network */
    printf( "\n\nOutput of neural network:\n" );

    for ( i=0; i < noOutputs; ++i )
    {
      printf( "Output %d: ", i+1 );
      printf( "%g\n", outputs[i] );
    }

    printf( "\nEnter next input pattern (for control menu inc. exit, enter %d for any input):\n", MENUCODE );
  }

  return 0;
}
